#include <cstdio>
#include <vector>
#include <set>
#include <iostream>


const int Q=2007;

int n,m;

char v[Q][Q];
int a[Q][Q];

int cont=0;

struct drept
{
    int sus,st,jos,dr;

    drept(int a, int b, int c, int d)
    {
        sus=a;
        st=b;
        jos=c;
        dr=d;
    }
};

std::vector<drept> t;


int sus,jos,st,dr;

int dx[]={0,1,0,-1};
int dy[]={1,0,-1,0};

void fill(int x, int y, int d)
{
    if(x<sus)
        sus=x;
    if(x>jos)
        jos=x;

    if(y<st)
        st=y;
    if(y>dr)
        dr=y;

    a[x][y]=d;

    for(int k=0; k<4; k++)
    {
        if(v[x+dx[k]][y+dy[k]]==v[x][y] && a[x+dx[k]][y+dy[k]]==0)
            fill(x+dx[k],y+dy[k],d);
    }
}

int drjos[Q][Q];

void precalc()
{
    t.push_back(drept(0,0,0,0));
    for(int i=1; i<=n; i++)
    {
        for(int j=1; j<=m; j++)
        {
            if(a[i][j]==0)
            {
                sus=Q;
                jos=0;
                st=Q;
                dr=0;
                fill(i,j,++cont);

                t.push_back(drept(sus,st,jos,dr));
                drjos[jos][dr]++;
            }
        }
    }

    for(int i=1; i<=n; i++)
    {
        for(int j=1; j<=m; j++)
        {
            drjos[i][j]+=drjos[i-1][j]+drjos[i][j-1]-drjos[i-1][j-1];
        }
    }
}


std::set<int> aux;

int numara_partial(int x1, int y1, int x2, int y2, int myt)
{
    aux.clear();

    for(int i=x1; i<=x2; i++)
    {
        if(a[i][y1]==a[i][y1-1])
        {
            aux.insert(a[i][y1]);
        }
        if(a[i][y2]==a[i][y2+1])
        {
            aux.insert(a[i][y2]);
        }
    }
    for(int j=y1; j<=y2; j++)
    {
        if(a[x1][j]==a[x1-1][j])
        {
            aux.insert(a[x1][j]);
        }
        if(a[x2][j]==a[x2+1][j])
        {
            aux.insert(a[x2][j]);
        }
    }

    return aux.size();;
}





int q;

int timp[Q*Q];

int main()
{
    freopen("camere.in","r",stdin);
    freopen("camere.out","w",stdout);

    scanf("%d %d\n",&n,&m);
    
    for(int i=1; i<=n; i++)
    {
        fgets(v[i]+1,Q,stdin);
    }

    precalc();

    scanf("%d\n",&q);

    int x1,y1,x2,y2;

    std::set<int> gl;

    for(int i=1; i<=q; i++)
    {
        gl.clear();
        //cin>>x1>>y1>>x2>>y2;
        scanf("%d%d%d%d",&x1,&y1,&x2,&y2);

        int rez=drjos[x2][y2]-drjos[x1-1][y2]-drjos[x2][y1-1]+drjos[x1-1][y1-1];

        int th;

        for(int x=x2; x; x--)
        {
            if(a[x][y1]==a[x][y1-1])
            {
                th=a[x][y1];
                if(t[th].jos<=x2 && t[th].jos>=x1)
                {
                    if(t[th].dr<=y2 && t[th].dr>=y1)
                    {
                        gl.insert(th);
                    }
                }
            }
        }

        for(int y=y2; y; y--)
        {
            if(a[x1][y]==a[x1-1][y])
            {
                th=a[x1][y];
                 if(t[th].jos<=x2 && t[th].jos>=x1)
                {
                    if(t[th].dr<=y2 && t[th].dr>=y1)
                    {
                        gl.insert(th);
                    }
                }
            }
        }

        rez-=gl.size();
        int rez2=numara_partial(x1,y1,x2,y2, i);

        //std::cerr<<i<<"\n";

        printf("%d\n",rez+rez2);
    }

    return 0;
}
