#include <bits/stdc++.h>

using namespace std;

#define mp make_pair
#define pb push_back
#define ll long long

const int NMAX = 3 * 1e5;
const int MMAX = 1e6;
const int nmax = NMAX + 5;
const int mmax = MMAX + 6;


struct Edge {
	int x, y, cul;
	Edge() {}
	Edge(int x, int y, int cul): x(x), y(y), cul(cul) {}
};

int n, m;
vector< pair<int, int >> gf[nmax];
vector< pair<int, int> > verifGf[nmax];
vector <Edge> edges;
int nextId = 0;
int viz[mmax];
int scoasa[mmax];


void assertRange(int &val, int minVal, int maxVal) {
	assert(val >= minVal && val <= maxVal);
}

int getNextId() {
	++nextId;
	return nextId;
}

// void removeEdge(int x, int y) {
// 	for (auto it = gf[x].begin(); it != gf[x].end(); ++it) {
// 		if (it->first == y) {
// 			gf[x].erase(it);
// 			break;
// 		}
// 	}
// }

void dfs(int node) {
	for (; !gf[node].empty(); ) {
		auto it = gf[node].end();
		--it;
		int idEdge = it->second;
		if (scoasa[idEdge]) {
			gf[node].pop_back();
			continue;
		}
		scoasa[idEdge] = 1;
		int vc = it->first;
		// removeEdge(node, vc);
		// removeEdge(vc, node);

		assert(edges[idEdge].cul == -1);

		edges[idEdge].cul = getNextId();

		dfs(vc);
	}
}

int gcd(int a, int b) {
	if (!b) {
		return a;
	}
	return gcd(b, a % b);
}

int main() {
	ios::sync_with_stdio(false);
#ifndef ONLINE_JUDGE
	freopen("nogcd.in", "r", stdin);
	freopen("nogcd.out", "w", stdout);
#endif

	cin >> n >> m;
	assertRange(n, 1, NMAX);
	assertRange(m, 1, MMAX);
	for (int i = 1; i <= m; ++i) {
		int x, y;
		cin >> x >> y;
		gf[x].pb(mp(y, edges.size()) );
		gf[y].pb(mp(x, edges.size()));
		verifGf[x].pb(mp(y, edges.size()) );
		verifGf[y].pb(mp(x, edges.size()));
		edges.pb(Edge(x, y, -1));
	}

	// for (int i = 1; i <= n; ++i) {
	// 	dfs(1);
	// }
	dfs(1);
	for (int i = 0; i < edges.size(); ++i) {
		assert(edges[i].cul >= 1);
		viz[edges[i].cul]++;
	}

	for (int i = 1; i <= m; ++i) {
		assert(viz[i] == 1);
	}
	// for (int i = 1; i <= n; ++i) {
	// 	assert(verifGf[i].size() > 0);
	// 	if (verifGf[i].size() == 1) {
	// 		continue;
	// 	}
	// 	int currIdxEdge = -1;
	// 	int currGcd = -1;
	// 	int j = 1;
	// 	for (auto it = verifGf[i].begin(); it != verifGf[i].end(); ++it, ++j) {
	// 		currIdxEdge = it->second;
	// 		if (j == 1) {
	// 			currGcd = edges[currIdxEdge].cul;
	// 		} else {
	// 			assert(currGcd != -1);
	// 			currGcd = gcd(currGcd, edges[currIdxEdge].cul);
	// 		}
	// 	}
	// 	assert(currGcd == 1);
	// }
	for (auto e : edges) {
		cout << e.x << " " << e.y << " " << e.cul << "\n";
	}
	return 0;
}